<script setup lang="ts">
  const emits = defineEmits<{
    (e: 'publish'): void;
  }>();
  const el = ref<HTMLElement | null>(null);
  const { isAppointmentRunning } = useAppointment();
  const { isGuide } = useUser();
  const { setHoveringElement } = useTarget();

  const hovering = ref(false);

  const onMouseenter = () => {
    if (!isAppointmentRunning.value || !isGuide.value) return;
    hovering.value = true;
    setHoveringElement(el.value);
  };

  const onMouseleave = () => {
    if (!isAppointmentRunning.value || !isGuide.value) return;
    hovering.value = false;
    setHoveringElement(null);
  };
</script>
<template>
  <div ref="el" class="relative h-full" @mouseenter="onMouseenter" @mouseleave="onMouseleave">
    <slot />
    <div v-if="hovering" class="absolute right-0 top-0 z-50 flex items-start justify-end">
      <SwButton class="!p-2" variant="action" @click="emits('publish')">
        <span class="i-sw-solid:crosshair text-base" />
      </SwButton>
    </div>
  </div>
</template>
